

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Kconfig macro language &mdash; Xen 4.16-unstable documentation</title>
  

  
  
  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../genindex.html"/>
        <link rel="search" title="Search" href="../search.html"/>
    <link rel="top" title="Xen 4.16-unstable documentation" href="../index.html"/> 

  
  <script src="../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../index.html" class="icon icon-home"> Xen
          

          
          </a>

          
            
            
              <div class="version">
                4.16
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../admin-guide/index.html">Admin Guide</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../guest-guide/index.html">Guest documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../hypervisor-guide/index.html">Hypervisor documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../hypercall-interfaces/index.html">Hypercall Interfaces</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../glossary.html">Glossary</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">Xen</a>
        
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../index.html">Docs</a> &raquo;</li>
        
      <li>Kconfig macro language</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../_sources/misc/kconfig-macro-language.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="kconfig-macro-language">
<h1>Kconfig macro language<a class="headerlink" href="#kconfig-macro-language" title="Permalink to this headline">¶</a></h1>
<div class="section" id="concept">
<h2>Concept<a class="headerlink" href="#concept" title="Permalink to this headline">¶</a></h2>
<p>The basic idea was inspired by Make. When we look at Make, we notice sort of
two languages in one. One language describes dependency graphs consisting of
targets and prerequisites. The other is a macro language for performing textual
substitution.</p>
<p>There is clear distinction between the two language stages. For example, you
can write a makefile like follows:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>APP := foo
SRC := foo.c
CC := gcc

$(APP): $(SRC)
        $(CC) -o $(APP) $(SRC)
</pre></div>
</div>
<p>The macro language replaces the variable references with their expanded form,
and handles as if the source file were input like follows:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>foo: foo.c
        gcc -o foo foo.c
</pre></div>
</div>
<p>Then, Make analyzes the dependency graph and determines the targets to be
updated.</p>
<p>The idea is quite similar in Kconfig - it is possible to describe a Kconfig
file like this:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>CC := gcc

config CC_HAS_FOO
        def_bool $(shell, $(srctree)/scripts/gcc-check-foo.sh $(CC))
</pre></div>
</div>
<p>The macro language in Kconfig processes the source file into the following
intermediate:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config CC_HAS_FOO
        def_bool y
</pre></div>
</div>
<p>Then, Kconfig moves onto the evaluation stage to resolve inter-symbol
dependency as explained in kconfig-language.txt.</p>
</div>
<div class="section" id="variables">
<h2>Variables<a class="headerlink" href="#variables" title="Permalink to this headline">¶</a></h2>
<p>Like in Make, a variable in Kconfig works as a macro variable.  A macro
variable is expanded “in place” to yield a text string that may then be
expanded further. To get the value of a variable, enclose the variable name in
$( ). The parentheses are required even for single-letter variable names; $X is
a syntax error. The curly brace form as in ${CC} is not supported either.</p>
<p>There are two types of variables: simply expanded variables and recursively
expanded variables.</p>
<p>A simply expanded variable is defined using the := assignment operator. Its
righthand side is expanded immediately upon reading the line from the Kconfig
file.</p>
<p>A recursively expanded variable is defined using the = assignment operator.
Its righthand side is simply stored as the value of the variable without
expanding it in any way. Instead, the expansion is performed when the variable
is used.</p>
<p>There is another type of assignment operator; += is used to append text to a
variable. The righthand side of += is expanded immediately if the lefthand
side was originally defined as a simple variable. Otherwise, its evaluation is
deferred.</p>
<p>The variable reference can take parameters, in the following form:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>$(name,arg1,arg2,arg3)
</pre></div>
</div>
<p>You can consider the parameterized reference as a function. (more precisely,
“user-defined function” in contrast to “built-in function” listed below).</p>
<p>Useful functions must be expanded when they are used since the same function is
expanded differently if different parameters are passed. Hence, a user-defined
function is defined using the = assignment operator. The parameters are
referenced within the body definition with $(1), $(2), etc.</p>
<p>In fact, recursively expanded variables and user-defined functions are the same
internally. (In other words, “variable” is “function with zero argument”.)
When we say “variable” in a broad sense, it includes “user-defined function”.</p>
</div>
<div class="section" id="built-in-functions">
<h2>Built-in functions<a class="headerlink" href="#built-in-functions" title="Permalink to this headline">¶</a></h2>
<p>Like Make, Kconfig provides several built-in functions. Every function takes a
particular number of arguments.</p>
<p>In Make, every built-in function takes at least one argument. Kconfig allows
zero argument for built-in functions, such as $(fileno), $(lineno). You could
consider those as “built-in variable”, but it is just a matter of how we call
it after all. Let’s say “built-in function” here to refer to natively supported
functionality.</p>
<p>Kconfig currently supports the following built-in functions.</p>
<blockquote>
<div><ul class="simple">
<li>$(shell,command)</li>
</ul>
<blockquote>
<div>The “shell” function accepts a single argument that is expanded and passed
to a subshell for execution. The standard output of the command is then read
and returned as the value of the function. Every newline in the output is
replaced with a space. Any trailing newlines are deleted. The standard error
is not returned, nor is any program exit status.</div></blockquote>
<ul class="simple">
<li>$(info,text)</li>
</ul>
<blockquote>
<div>The “info” function takes a single argument and prints it to stdout.
It evaluates to an empty string.</div></blockquote>
<ul class="simple">
<li>$(warning-if,condition,text)</li>
</ul>
<blockquote>
<div>The “warning-if” function takes two arguments. If the condition part is “y”,
the text part is sent to stderr. The text is prefixed with the name of the
current Kconfig file and the current line number.</div></blockquote>
<ul class="simple">
<li>$(error-if,condition,text)</li>
</ul>
<blockquote>
<div>The “error-if” function is similar to “warning-if”, but it terminates the
parsing immediately if the condition part is “y”.</div></blockquote>
<ul class="simple">
<li>$(filename)</li>
</ul>
<blockquote>
<div>The ‘filename’ takes no argument, and $(filename) is expanded to the file
name being parsed.</div></blockquote>
<ul class="simple">
<li>$(lineno)</li>
</ul>
<blockquote>
<div>The ‘lineno’ takes no argument, and $(lineno) is expanded to the line number
being parsed.</div></blockquote>
</div></blockquote>
</div>
<div class="section" id="make-vs-kconfig">
<h2>Make vs Kconfig<a class="headerlink" href="#make-vs-kconfig" title="Permalink to this headline">¶</a></h2>
<p>Kconfig adopts Make-like macro language, but the function call syntax is
slightly different.</p>
<p>A function call in Make looks like this:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>$(func-name arg1,arg2,arg3)
</pre></div>
</div>
<p>The function name and the first argument are separated by at least one
whitespace. Then, leading whitespaces are trimmed from the first argument,
while whitespaces in the other arguments are kept. You need to use a kind of
trick to start the first parameter with spaces. For example, if you want
to make “info” function print ”  hello”, you can write like follows:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>empty :=
space := $(empty) $(empty)
$(info $(space)$(space)hello)
</pre></div>
</div>
<p>Kconfig uses only commas for delimiters, and keeps all whitespaces in the
function call. Some people prefer putting a space after each comma delimiter:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>$(func-name, arg1, arg2, arg3)
</pre></div>
</div>
<p>In this case, “func-name” will receive ” arg1”, ” arg2”, ” arg3”. The presence
of leading spaces may matter depending on the function. The same applies to
Make - for example, $(subst .c, .o, $(sources)) is a typical mistake; it
replaces “.c” with ” .o”.</p>
<p>In Make, a user-defined function is referenced by using a built-in function,
‘call’, like this:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>$(call my-func,arg1,arg2,arg3)
</pre></div>
</div>
<p>Kconfig invokes user-defined functions and built-in functions in the same way.
The omission of ‘call’ makes the syntax shorter.</p>
<p>In Make, some functions treat commas verbatim instead of argument separators.
For example, $(shell echo hello, world) runs the command “echo hello, world”.
Likewise, $(info hello, world) prints “hello, world” to stdout. You could say
this is _useful_ inconsistency.</p>
<p>In Kconfig, for simpler implementation and grammatical consistency, commas that
appear in the $( ) context are always delimiters. It means:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>$(shell, echo hello, world)
</pre></div>
</div>
<p>is an error because it is passing two parameters where the ‘shell’ function
accepts only one. To pass commas in arguments, you can use the following trick:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>comma := ,
$(shell, echo hello$(comma) world)
</pre></div>
</div>
</div>
<div class="section" id="caveats">
<h2>Caveats<a class="headerlink" href="#caveats" title="Permalink to this headline">¶</a></h2>
<p>A variable (or function) cannot be expanded across tokens. So, you cannot use
a variable as a shorthand for an expression that consists of multiple tokens.
The following works:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>RANGE_MIN := 1
RANGE_MAX := 3

config FOO
        int &quot;foo&quot;
        range $(RANGE_MIN) $(RANGE_MAX)
</pre></div>
</div>
<p>But, the following does not work:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>RANGES := 1 3

config FOO
        int &quot;foo&quot;
        range $(RANGES)
</pre></div>
</div>
<p>A variable cannot be expanded to any keyword in Kconfig.  The following does
not work:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>MY_TYPE := tristate

config FOO
        $(MY_TYPE) &quot;foo&quot;
        default y
</pre></div>
</div>
<p>Obviously from the design, $(shell command) is expanded in the textual
substitution phase. You cannot pass symbols to the ‘shell’ function.</p>
<p>The following does not work as expected:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config ENDIAN_FLAG
        string
        default &quot;-mbig-endian&quot; if CPU_BIG_ENDIAN
        default &quot;-mlittle-endian&quot; if CPU_LITTLE_ENDIAN

config CC_HAS_ENDIAN_FLAG
        def_bool $(shell $(srctree)/scripts/gcc-check-flag ENDIAN_FLAG)
</pre></div>
</div>
<p>Instead, you can do like follows so that any function call is statically
expanded:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config CC_HAS_ENDIAN_FLAG
        bool
        default $(shell $(srctree)/scripts/gcc-check-flag -mbig-endian) if CPU_BIG_ENDIAN
        default $(shell $(srctree)/scripts/gcc-check-flag -mlittle-endian) if CPU_LITTLE_ENDIAN
</pre></div>
</div>
</div>
</div>


           </div>
           <div class="articleComments">
            
           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, The Xen development community.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../',
            VERSION:'4.16-unstable',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="../_static/jquery.js"></script>
      <script type="text/javascript" src="../_static/underscore.js"></script>
      <script type="text/javascript" src="../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>